Index: branches/HTM-14.1-update-dev0/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1200)
@@ -966,142 +1113,27 @@
   //  inter_view_mv_vert_constraint_flag shall be equal to 1 
   //  in the sps_multilayer_extension( ) syntax structure in each active SPS for that layer.
-  if( m_apcSlicePilot->getSPS()->getPTL()->getGeneralPTL()->getProfileIdc()==Profile::MULTIVIEWMAIN
+  if( pcSlice->getSPS()->getPTL()->getGeneralPTL()->getProfileIdc()==Profile::MULTIVIEWMAIN
       &&
-      m_apcSlicePilot->getVPS()->getViewOrderIdx(m_apcSlicePilot->getVPS()->getLayerIdInNuh(getLayerId()))==1 
+      pcSlice->getVPS()->getViewOrderIdx(pcSlice->getVPS()->getLayerIdInNuh(getLayerId()))==1 
      )
   {
-    assert( m_apcSlicePilot->getSPS()->getInterViewMvVertConstraintFlag()==1 );
-  }
-#endif
-
-  if (m_apcSlicePilot->isNextSlice()) 
-  {
-    m_prevPOC = m_apcSlicePilot->getPOC();
-  }
-  m_bFirstSliceInSequence = false;
-#if SETTING_NO_OUT_PIC_PRIOR  
-  m_bFirstSliceInBitstream  = false;
-#endif
-  //detect lost reference picture and insert copy of earlier frame.
-  Int lostPoc;
-  while((lostPoc=m_apcSlicePilot->checkThatAllRefPicsAreAvailable(m_cListPic, m_apcSlicePilot->getRPS(), true, m_pocRandomAccess)) > 0)
-  {
-    xCreateLostPicture(lostPoc-1);
-  }
-  if (m_bFirstSliceInPicture)
-  {
-    // Buffer initialize for prediction.
-    m_cPrediction.initTempBuff();
-    m_apcSlicePilot->applyReferencePictureSet(m_cListPic, m_apcSlicePilot->getRPS());
-#if H_MV
-    m_apcSlicePilot->createInterLayerReferencePictureSet( m_ivPicLists, m_refPicSetInterLayer0, m_refPicSetInterLayer1 ); 
-#endif
-    //  Get a new picture buffer
-    xGetNewPicBuffer (m_apcSlicePilot, pcPic);
-
-    Bool isField = false;
-    Bool isTff = false;
-    
-    if(!m_SEIs.empty())
-    {
-      // Check if any new Picture Timing SEI has arrived
-      SEIMessages pictureTimingSEIs = extractSeisByType (m_SEIs, SEI::PICTURE_TIMING);
-      if (pictureTimingSEIs.size()>0)
-      {
-        SEIPictureTiming* pictureTiming = (SEIPictureTiming*) *(pictureTimingSEIs.begin());
-        isField = (pictureTiming->m_picStruct == 1) || (pictureTiming->m_picStruct == 2);
-        isTff =  (pictureTiming->m_picStruct == 1);
-      }
-    }
-    
-    //Set Field/Frame coding mode
-    m_pcPic->setField(isField);
-    m_pcPic->setTopField(isTff);
-    
-    // transfer any SEI messages that have been received to the picture
-    pcPic->setSEIs(m_SEIs);
-    m_SEIs.clear();
-
-    // Recursive structure
-    m_cCuDecoder.create ( g_uiMaxCUDepth, g_uiMaxCUWidth, g_uiMaxCUHeight );
-    m_cCuDecoder.init   ( &m_cEntropyDecoder, &m_cTrQuant, &m_cPrediction );
-    m_cTrQuant.init     ( g_uiMaxCUWidth, g_uiMaxCUHeight, m_apcSlicePilot->getSPS()->getMaxTrSize());
-
-    m_cSliceDecoder.create();
-  }
-  else
-  {
-    // Check if any new SEI has arrived
-    if(!m_SEIs.empty())
-    {
-      // Currently only decoding Unit SEI message occurring between VCL NALUs copied
-      SEIMessages &picSEI = pcPic->getSEIs();
-      SEIMessages decodingUnitInfos = extractSeisByType (m_SEIs, SEI::DECODING_UNIT_INFO);
-      picSEI.insert(picSEI.end(), decodingUnitInfos.begin(), decodingUnitInfos.end());
-      deleteSEIs(m_SEIs);
-    }
-  }
-  
-  //  Set picture slice pointer
-  TComSlice*  pcSlice = m_apcSlicePilot;
-  Bool bNextSlice     = pcSlice->isNextSlice();
-
-  UInt i;
-  pcPic->getPicSym()->initTiles(pcSlice->getPPS());
-
-  //generate the Coding Order Map and Inverse Coding Order Map
-  UInt uiEncCUAddr;
-  for(i=0, uiEncCUAddr=0; i<pcPic->getPicSym()->getNumberOfCUsInFrame(); i++, uiEncCUAddr = pcPic->getPicSym()->xCalculateNxtCUAddr(uiEncCUAddr))
-  {
-    pcPic->getPicSym()->setCUOrderMap(i, uiEncCUAddr);
-    pcPic->getPicSym()->setInverseCUOrderMap(uiEncCUAddr, i);
-  }
-  pcPic->getPicSym()->setCUOrderMap(pcPic->getPicSym()->getNumberOfCUsInFrame(), pcPic->getPicSym()->getNumberOfCUsInFrame());
-  pcPic->getPicSym()->setInverseCUOrderMap(pcPic->getPicSym()->getNumberOfCUsInFrame(), pcPic->getPicSym()->getNumberOfCUsInFrame());
-
-  //convert the start and end CU addresses of the slice and dependent slice into encoding order
-  pcSlice->setSliceSegmentCurStartCUAddr( pcPic->getPicSym()->getPicSCUEncOrder(pcSlice->getSliceSegmentCurStartCUAddr()) );
-  pcSlice->setSliceSegmentCurEndCUAddr( pcPic->getPicSym()->getPicSCUEncOrder(pcSlice->getSliceSegmentCurEndCUAddr()) );
-  if(pcSlice->isNextSlice())
-  {
-    pcSlice->setSliceCurStartCUAddr(pcPic->getPicSym()->getPicSCUEncOrder(pcSlice->getSliceCurStartCUAddr()));
-    pcSlice->setSliceCurEndCUAddr(pcPic->getPicSym()->getPicSCUEncOrder(pcSlice->getSliceCurEndCUAddr()));
-  }
-
-  if (m_bFirstSliceInPicture) 
-  {
-    if(pcPic->getNumAllocatedSlice() != 1)
-    {
-      pcPic->clearSliceBuffer();
-    }
-  }
-  else
-  {
-    pcPic->allocateNewSlice();
-  }
-  assert(pcPic->getNumAllocatedSlice() == (m_uiSliceIdx + 1));
-  m_apcSlicePilot = pcPic->getPicSym()->getSlice(m_uiSliceIdx); 
-  pcPic->getPicSym()->setSlice(pcSlice, m_uiSliceIdx);
-
-  pcPic->setTLayer(nalu.m_temporalId);
-
-#if H_MV
-  pcPic->setLayerId( nalu.m_layerId );
-  pcPic->setViewId ( getViewId() );
-#if H_3D
-  pcPic->setViewIndex( getViewIndex() );
-  pcPic->setIsDepth  ( getIsDepth  () );
+    assert( pcSlice->getSPS()->getInterViewMvVertConstraintFlag()==1 );
+  }
+#endif
+#if NH_MV
+  m_pcPic->setLayerId( nalu.m_nuhLayerId );
+  m_pcPic->setViewId ( getViewId() );
+#if NH_3D
+  m_pcPic->setViewIndex( getViewIndex() );
+  m_pcPic->setIsDepth  ( getIsDepth  () );
   pcSlice->setIvPicLists( m_ivPicLists );         
 #endif
 #endif
 
-
-
-
-  if (bNextSlice)
+  if (!pcSlice->getDependentSliceSegmentFlag())
   {
     pcSlice->checkCRA(pcSlice->getRPS(), m_pocCRA, m_associatedIRAPType, m_cListPic );
     // Set reference list
-#if H_MV    
+#if NH_MV    
     std::vector< TComPic* > tempRefPicLists[2];
     std::vector< Bool     > usedAsLongTerm [2];
@@ -1118,5 +1150,5 @@
     {
       // GT: This seems to be broken, not all nuh_layer_ids are necessarily present
-      for(Int iLayerId = 0; iLayerId < nalu.m_layerId; iLayerId ++ )
+      for(Int iLayerId = 0; iLayerId < nalu.m_nuhLayerId; iLayerId ++ )
       {
         Int  iViewIdx =   pcSlice->getVPS()->getViewIndex(iLayerId);
@@ -1133,5 +1165,5 @@
 #endif
 
-#if H_3D
+#if NH_3D
     pcSlice->checkInCompPredRefLayers(); 
 #if H_3D_IV_MERGE
@@ -1143,5 +1175,5 @@
 #endif    
 #endif
-#if H_MV
+#if NH_MV
     if( m_layerId > 0 && !pcSlice->isIntra() && pcSlice->getEnableTMVPFlag() )
     {
@@ -1186,8 +1218,8 @@
             bLowDelay = false;
           }
-        }        
-      }
-
-      pcSlice->setCheckLDC(bLowDelay);            
+        }
+      }
+
+      pcSlice->setCheckLDC(bLowDelay);
     }
 
@@ -1202,22 +1234,31 @@
   }
 
-  pcPic->setCurrSliceIdx(m_uiSliceIdx);
+  m_pcPic->setCurrSliceIdx(m_uiSliceIdx);
   if(pcSlice->getSPS()->getScalingListFlag())
   {
-    pcSlice->setScalingList ( pcSlice->getSPS()->getScalingList()  );
+    TComScalingList scalingList;
     if(pcSlice->getPPS()->getScalingListPresentFlag())
     {
-      pcSlice->setScalingList ( pcSlice->getPPS()->getScalingList()  );
-    }
-    if(!pcSlice->getPPS()->getScalingListPresentFlag() && !pcSlice->getSPS()->getScalingListPresentFlag())
-    {
-      pcSlice->setDefaultScalingList();
-    }
-    m_cTrQuant.setScalingListDec(pcSlice->getScalingList());
+      scalingList = pcSlice->getPPS()->getScalingList();
+    }
+    else if (pcSlice->getSPS()->getScalingListPresentFlag())
+    {
+      scalingList = pcSlice->getSPS()->getScalingList();
+    }
+    else
+    {
+      scalingList.setDefaultScalingList();
+    }
+    m_cTrQuant.setScalingListDec(scalingList);
     m_cTrQuant.setUseScalingList(true);
   }
   else
   {
-    m_cTrQuant.setFlatScalingList();
+    const Int maxLog2TrDynamicRange[MAX_NUM_CHANNEL_TYPE] =
+    {
+        pcSlice->getSPS()->getMaxLog2TrDynamicRange(CHANNEL_TYPE_LUMA),
+        pcSlice->getSPS()->getMaxLog2TrDynamicRange(CHANNEL_TYPE_CHROMA)
+    };
+    m_cTrQuant.setFlatScalingList(maxLog2TrDynamicRange, pcSlice->getSPS()->getBitDepths());
     m_cTrQuant.setUseScalingList(false);
   }
@@ -1233,8 +1274,8 @@
   }
 #endif
-
   //  Decode a picture
-  m_cGopDecoder.decompressSlice(nalu.m_Bitstream, pcPic);
-#if H_3D
+  m_cGopDecoder.decompressSlice(&(nalu.getBitstream()), m_pcPic);
+
+#if NH_3D
   if( m_pcCamParsCollector )
   {
@@ -1242,4 +1283,5 @@
   }
 #endif
+
   m_bFirstSliceInPicture = false;
   m_uiSliceIdx++;
@@ -1248,88 +1290,43 @@
 }
 
-Void TDecTop::xDecodeVPS()
+Void TDecTop::xDecodeVPS(const std::vector<UChar> &naluData)
 {
   TComVPS* vps = new TComVPS();
-  
+
   m_cEntropyDecoder.decodeVPS( vps );
-  m_parameterSetManagerDecoder.storePrefetchedVPS(vps);  
-}
-
-Void TDecTop::xDecodeSPS()
+  m_parameterSetManager.storeVPS(vps, naluData);
+}
+
+Void TDecTop::xDecodeSPS(const std::vector<UChar> &naluData)
 {
   TComSPS* sps = new TComSPS();
-#if H_MV
+#if NH_MV
   sps->setLayerId( getLayerId() ); 
 #endif
+#if O0043_BEST_EFFORT_DECODING
+  sps->setForceDecodeBitDepth(m_forceDecodeBitDepth);
+#endif
+#if NH_3D
+  // GT: Please don't add parsing dependency of SPS from VPS here again!!!
+#endif
+  m_cEntropyDecoder.decodeSPS( sps );
+  m_parameterSetManager.storeSPS(sps, naluData);
+}
+
+Void TDecTop::xDecodePPS(const std::vector<UChar> &naluData)
+{
+  TComPPS* pps = new TComPPS();
+#if NH_MV
+  pps->setLayerId( getLayerId() ); 
+#endif
 #if H_3D
-  // Preliminary fix. assuming that all sps refer to the same VPS. 
-  // Parsing dependency should be resolved!
-  TComVPS* vps = m_parameterSetManagerDecoder.getPrefetchedVPS( 0 ); 
-  assert( vps != 0 );
-  m_cEntropyDecoder.decodeSPS( sps );
-#else
-  m_cEntropyDecoder.decodeSPS( sps );
-#endif
-  m_parameterSetManagerDecoder.storePrefetchedSPS(sps);
-}
-
-Void TDecTop::xDecodePPS()
-{
-  TComPPS* pps = new TComPPS();
-#if H_MV
-  pps->setLayerId( getLayerId() ); 
-#endif
-#if H_3D
-  // Assuming that all PPS indirectly refer to the same VPS via different SPS
-  // There is no parsing dependency in decoding DLT in PPS. 
-  // The VPS information passed to decodePPS() is used to arrange the decoded DLT tables to their corresponding layers. 
-  // This is equivalent to the process of 
-  //   Step 1) decoding DLT tables based on the number of depth layers, and
-  //   Step 2) mapping DLT tables to the depth layers
-  // as described in the 3D-HEVC WD. 
-  TComVPS* vps = m_parameterSetManagerDecoder.getPrefetchedVPS( 0 );
-  m_cEntropyDecoder.decodePPS( pps, vps );
-#else
+  // GT: Please don't add parsing dependency of SPS from VPS here again!!!
+#endif
   m_cEntropyDecoder.decodePPS( pps );
-#endif
-  m_parameterSetManagerDecoder.storePrefetchedPPS( pps );
-}
-
-Void TDecTop::xDecodeSEI( TComInputBitstream* bs, const NalUnitType nalUnitType )
-{
-  if(nalUnitType == NAL_UNIT_SUFFIX_SEI)
-  {
-#if H_MV
-    m_seiReader.parseSEImessage( bs, m_pcPic->getSEIs(), nalUnitType, m_parameterSetManagerDecoder.getActiveSPS( m_layerId ) );
-#else
-    m_seiReader.parseSEImessage( bs, m_pcPic->getSEIs(), nalUnitType, m_parameterSetManagerDecoder.getActiveSPS() );
-#endif
-  }
-  else
-  {
-#if H_MV
-    m_seiReader.parseSEImessage( bs, m_SEIs, nalUnitType, m_parameterSetManagerDecoder.getActiveSPS( m_layerId ) );
-#else
-    m_seiReader.parseSEImessage( bs, m_SEIs, nalUnitType, m_parameterSetManagerDecoder.getActiveSPS() );
-#endif
-    SEIMessages activeParamSets = getSeisByType(m_SEIs, SEI::ACTIVE_PARAMETER_SETS);
-    if (activeParamSets.size()>0)
-    {
-      SEIActiveParameterSets *seiAps = (SEIActiveParameterSets*)(*activeParamSets.begin());
-      m_parameterSetManagerDecoder.applyPrefetchedPS();
-      assert(seiAps->activeSeqParameterSetId.size()>0);
-#if H_MV
-      if (! m_parameterSetManagerDecoder.activateSPSWithSEI(seiAps->activeSeqParameterSetId[0], m_layerId ))
-#else
-      if (! m_parameterSetManagerDecoder.activateSPSWithSEI(seiAps->activeSeqParameterSetId[0] ))
-#endif
-      {
-        printf ("Warning SPS activation with Active parameter set SEI failed");
-      }
-    }
-  }
-}
-
-#if H_MV
+
+  m_parameterSetManager.storePPS( pps, naluData);
+}
+
+#if NH_MV
 Bool TDecTop::decode(InputNALUnit& nalu, Int& iSkipFrame, Int& iPOCLastDisplay, Bool newLayerFlag, Bool& sliceSkippedFlag )
 #else
@@ -1337,28 +1334,40 @@
 #endif
 {
+#if !NH_MV
+  // ignore all NAL units of layers > 0
+  if (nalu.m_nuhLayerId > 0)
+  {
+    fprintf (stderr, "Warning: found NAL unit with nuh_layer_id equal to %d. Ignoring.\n", nalu.m_nuhLayerId);
+    return false;
+  }
+#endif
   // Initialize entropy decoder
   m_cEntropyDecoder.setEntropyDecoder (&m_cCavlcDecoder);
-  m_cEntropyDecoder.setBitstream      (nalu.m_Bitstream);
+  m_cEntropyDecoder.setBitstream      (&(nalu.getBitstream()));
 
   switch (nalu.m_nalUnitType)
   {
     case NAL_UNIT_VPS:
-      xDecodeVPS();
-#if H_MV
+      xDecodeVPS(nalu.getBitstream().getFifo());
+#if NH_MV
       m_isLastNALWasEos = false;
 #endif
       return false;
-      
+
     case NAL_UNIT_SPS:
-      xDecodeSPS();
+      xDecodeSPS(nalu.getBitstream().getFifo());
       return false;
 
     case NAL_UNIT_PPS:
-      xDecodePPS();
+      xDecodePPS(nalu.getBitstream().getFifo());
       return false;
-      
+
     case NAL_UNIT_PREFIX_SEI:
+      // Buffer up prefix SEI messages until SPS of associated VCL is known.
+      m_prefixSEINALUs.push_back(new InputNALUnit(nalu));
+      return false;
+
     case NAL_UNIT_SUFFIX_SEI:
-#if H_MV
+#if NH_MV
       if ( nalu.m_nalUnitType == NAL_UNIT_SUFFIX_SEI )
       {
@@ -1366,5 +1375,16 @@
       }
 #endif
-      xDecodeSEI( nalu.m_Bitstream, nalu.m_nalUnitType );
+      if (m_pcPic)
+      {
+#if NH_MV
+        m_seiReader.parseSEImessage( &(nalu.getBitstream()), m_pcPic->getSEIs(), nalu.m_nalUnitType, m_parameterSetManager.getActiveSPS( getLayerId() ), m_pDecodedSEIOutputStream );
+#else
+        m_seiReader.parseSEImessage( &(nalu.getBitstream()), m_pcPic->getSEIs(), nalu.m_nalUnitType, m_parameterSetManager.getActiveSPS(), m_pDecodedSEIOutputStream );
+#endif
+      }
+      else
+      {
+        printf ("Note: received suffix SEI but no picture currently active.\n");
+      }
       return false;
 
@@ -1385,5 +1405,5 @@
     case NAL_UNIT_CODED_SLICE_RASL_N:
     case NAL_UNIT_CODED_SLICE_RASL_R:
-#if H_MV
+#if NH_MV
       if (nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_TRAIL_R || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_TRAIL_N ||
           nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_TSA_R || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_TSA_N ||
@@ -1398,5 +1418,4 @@
         m_isLastNALWasEos = false;
       }
-
       return xDecodeSlice(nalu, iSkipFrame, iPOCLastDisplay, newLayerFlag, sliceSkippedFlag );
 #else
@@ -1404,9 +1423,10 @@
 #endif
       break;
+
     case NAL_UNIT_EOS:
-#if H_MV
+#if NH_MV
       assert( m_isLastNALWasEos == false );
       //Check layer id of the nalu. if it is not 0, give a warning message and just return without doing anything.
-      if (nalu.m_layerId > 0)
+      if (nalu.m_nuhLayerId > 0)
       {
         printf( "\nThis bitstream has EOS with non-zero layer id.\n" );
@@ -1419,23 +1439,32 @@
       m_pocRandomAccess = MAX_INT;
       m_prevPOC = MAX_INT;
-      m_bFirstSliceInPicture = true;
-      m_bFirstSliceInSequence = true;
       m_prevSliceSkipped = false;
       m_skippedPOC = 0;
       return false;
-      
+
     case NAL_UNIT_ACCESS_UNIT_DELIMITER:
-      // TODO: process AU delimiter
+      {
+        AUDReader audReader;
+        UInt picType;
+        audReader.parseAccessUnitDelimiter(&(nalu.getBitstream()),picType);
+        printf ("Note: found NAL_UNIT_ACCESS_UNIT_DELIMITER\n");
       return false;
-      
+      }
+
     case NAL_UNIT_EOB:
       return false;
-      
+
     case NAL_UNIT_FILLER_DATA:
-#if H_MV
+      {
+        FDReader fdReader;
+        UInt size;
+        fdReader.parseFillerData(&(nalu.getBitstream()),size);
+        printf ("Note: found NAL_UNIT_FILLER_DATA with %u bytes payload.\n", size);
+#if NH_MV
       assert( m_isLastNALWasEos == false );
 #endif
       return false;
-      
+      }
+
     case NAL_UNIT_RESERVED_VCL_N10:
     case NAL_UNIT_RESERVED_VCL_R11:
@@ -1444,8 +1473,8 @@
     case NAL_UNIT_RESERVED_VCL_N14:
     case NAL_UNIT_RESERVED_VCL_R15:
-      
+
     case NAL_UNIT_RESERVED_IRAP_VCL22:
     case NAL_UNIT_RESERVED_IRAP_VCL23:
-      
+
     case NAL_UNIT_RESERVED_VCL24:
     case NAL_UNIT_RESERVED_VCL25:
@@ -1456,5 +1485,8 @@
     case NAL_UNIT_RESERVED_VCL30:
     case NAL_UNIT_RESERVED_VCL31:
-      
+      printf ("Note: found reserved VCL NAL unit.\n");
+      xParsePrefixSEIsForUnknownVCLNal();
+      return false;
+
     case NAL_UNIT_RESERVED_NVCL41:
     case NAL_UNIT_RESERVED_NVCL42:
@@ -1464,4 +1496,6 @@
     case NAL_UNIT_RESERVED_NVCL46:
     case NAL_UNIT_RESERVED_NVCL47:
+      printf ("Note: found reserved NAL unit.\n");
+      return false;
     case NAL_UNIT_UNSPECIFIED_48:
     case NAL_UNIT_UNSPECIFIED_49:
@@ -1480,6 +1514,9 @@
     case NAL_UNIT_UNSPECIFIED_62:
     case NAL_UNIT_UNSPECIFIED_63:
+      printf ("Note: found unspecified NAL unit.\n");
+      return false;
     default:
       assert (0);
+      break;
   }
 
@@ -1495,5 +1532,5 @@
 Bool TDecTop::isSkipPictureForBLA(Int& iPOCLastDisplay)
 {
-  if ((m_associatedIRAPType == NAL_UNIT_CODED_SLICE_BLA_N_LP || m_associatedIRAPType == NAL_UNIT_CODED_SLICE_BLA_W_LP || m_associatedIRAPType == NAL_UNIT_CODED_SLICE_BLA_W_RADL) && 
+  if ((m_associatedIRAPType == NAL_UNIT_CODED_SLICE_BLA_N_LP || m_associatedIRAPType == NAL_UNIT_CODED_SLICE_BLA_W_LP || m_associatedIRAPType == NAL_UNIT_CODED_SLICE_BLA_W_RADL) &&
        m_apcSlicePilot->getPOC() < m_pocCRA && (m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_RASL_R || m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_RASL_N))
   {
@@ -1513,16 +1550,20 @@
  * If the random access point is CRA/CRANT/BLA/BLANT, TFD pictures with POC less than the POC of the random access point are skipped.
  * If the random access point is IDR all pictures after the random access point are decoded.
- * If the random access point is none of the above, a warning is issues, and decoding of pictures with POC 
- * equal to or greater than the random access point POC is attempted. For non IDR/CRA/BLA random 
+ * If the random access point is none of the above, a warning is issues, and decoding of pictures with POC
+ * equal to or greater than the random access point POC is attempted. For non IDR/CRA/BLA random
  * access point there is no guarantee that the decoder will not crash.
  */
-Bool TDecTop::isRandomAccessSkipPicture(Int& iSkipFrame,  Int& iPOCLastDisplay)
-{
-  if (iSkipFrame) 
+#if NH_MV
+Bool TDecTop::isRandomAccessSkipPicture(Int& iSkipFrame,  Int& iPOCLastDisplay, const TComVPS* vps)
+#else
+Bool TDecTop::isRandomAccessSkipPicture(Int& iSkipFrame,  Int& iPOCLastDisplay )
+#endif
+{
+  if (iSkipFrame)
   {
     iSkipFrame--;   // decrement the counter
     return true;
   }
-#if H_MV
+#if NH_MV
   else if ( !m_layerInitilizedFlag[ m_layerId ] ) // start of random access point, m_pocRandomAccess has not been set yet.
 #else
@@ -1536,6 +1577,6 @@
     {
 
-#if H_MV
-      if ( xAllRefLayersInitilized() )
+#if NH_MV
+      if ( xAllRefLayersInitilized( vps ) )
       {
         m_layerInitilizedFlag[ m_layerId ] = true; 
@@ -1553,6 +1594,6 @@
     else if ( m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR_W_RADL || m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR_N_LP )
     {
-#if H_MV
-      if ( xAllRefLayersInitilized() )
+#if NH_MV
+      if ( xAllRefLayersInitilized( vps) )
       {
         m_layerInitilizedFlag[ m_layerId ] = true; 
@@ -1567,7 +1608,7 @@
 #endif
     }
-    else 
-    {
-#if H_MV
+    else
+    {
+#if NH_MV
       static Bool warningMessage[MAX_NUM_LAYERS];
       static Bool warningInitFlag = false;
@@ -1588,9 +1629,8 @@
       }
 #else
-      static Bool warningMessage = false;
-      if(!warningMessage)
+      if(!m_warningMessageSkipPicture)
       {
         printf("\nWarning: this is not a valid random access point and the data is discarded until the first CRA picture");
-        warningMessage = true;
+        m_warningMessageSkipPicture = true;
       }
 #endif
@@ -1604,13 +1644,12 @@
     return true;
   }
-#if H_MV
+  // if we reach here, then the picture is not skipped.
+#if NH_MV
   return !m_layerInitilizedFlag[ getLayerId() ]; 
 #else
-  // if we reach here, then the picture is not skipped.
-  return false; 
-#endif
-}
-
-#if H_MV
+  return false;
+#endif
+}
+#if NH_MV
 TComPic* TDecTop::getPic( Int poc )
 {
@@ -1672,8 +1711,7 @@
 }
 
-Bool TDecTop::xAllRefLayersInitilized()
-{
-  Bool allRefLayersInitilizedFlag = true; 
-  TComVPS* vps = m_parameterSetManagerDecoder.getPrefetchedVPS( 0 ); 
+Bool TDecTop::xAllRefLayersInitilized( const TComVPS* vps )
+{
+  Bool allRefLayersInitilizedFlag = true;   
   for (Int i = 0; i < vps->getNumDirectRefLayers( getLayerId()  ); i++ )
   {
@@ -1685,28 +1723,32 @@
 }
 
-#if H_3D
-Void TDecTop::setProfileIdc()
-{
-  if (m_targetOptLayerSetIdx != -1 )
-  {    
-    TComVPS* vps = getPrefetchedVPS(); 
-    Int lsIdx = vps->olsIdxToLsIdx( m_targetOptLayerSetIdx );
-    Int lIdx = -1; 
-    for (Int j = 0; j < vps->getNumLayersInIdList( lsIdx ); j++ )
-    {
-      if ( vps->getLayerSetLayerIdList( lsIdx, j ) == getLayerId() )
-      {
-        lIdx = j; 
-        break; 
-      }        
-    }
-    assert( lIdx != -1 ); 
-
-    Int profileIdc = vps->getPTL( vps->getProfileTierLevelIdx( m_targetOptLayerSetIdx, lIdx ) )->getGeneralPTL()->getProfileIdc();
-    assert( profileIdc == 1 || profileIdc == 6 || profileIdc == 8 ); 
-    m_profileIdc = profileIdc;   
-  };
-}
-#endif
-#endif
+
+Void TDecTop::initFromActiveVps( const TComVPS* vps )
+{
+  if ( m_targetOlsIdx == -1 )
+  {
+    // Not normative! Corresponds to specification by "External Means". (Should be set equal to 0, when no external means available. ) 
+    m_targetOlsIdx = vps->getVpsNumLayerSetsMinus1(); 
+  }
+#if NH_3D
+  // Set profile
+  Int lsIdx = vps->olsIdxToLsIdx( m_targetOlsIdx );
+  Int lIdx = -1; 
+  for (Int j = 0; j < vps->getNumLayersInIdList( lsIdx ); j++ )
+  {
+    if ( vps->getLayerSetLayerIdList( lsIdx, j ) == getLayerId() )
+    {
+      lIdx = j; 
+      break; 
+    }        
+  }
+  assert( lIdx != -1 ); 
+
+  Int profileIdc = vps->getPTL( vps->getProfileTierLevelIdx( m_targetOlsIdx, lIdx ) )->getGeneralPTL()->getProfileIdc();
+  assert( profileIdc == 1 || profileIdc == 6 || profileIdc == 8 ); 
+  m_profileIdc = profileIdc;   
+#endif
+}
+#endif
+
 //! \}
